   include windows.inc
   include user32.inc
   include kernel32.inc
   include gdi32.inc
   
   includelib user32.lib
   includelib kernel32.lib
   includelib gdi32.lib

include \masm32\include\gdiplus\gdiplus.inc
include \masm32\include\gdiplus\gdiplus_structs.inc
includelib \masm32\lib\gdiplus.lib

	GdipTest proto :DWORD
.data
    _s  db 'gdi+ test proc...',0
    _n	db 'Arial',0
    _err db 'error',0
    _ok	db 'ok',0
    _r	RectF <10.0,20.0,0.0,0.0>
.code

GdipTest proc hwnd:dword

	LOCAL @dc	:dword
    local @gpsi :GdiplusStartupInput
    local @t    :dword  ;token
    local @g    :dword  ;graohics
    local @fm   :dword  ;fontfamily
    local @ft   :dword  ;font
    local @br   :dword  ;brush
    local @p    :dword  ;pen
    local @sf   :dword  ;string format
    local @r    :RectF
    local @ws   :dword  ;wide string
    local @sl   :dword  ;string length
    local @r4   :REAL4

    invoke RtlZeroMemory, addr @gpsi, sizeof GdiplusStartupInput
    mov @gpsi.GdiplusVersion, 1
    invoke GdiplusStartup, addr @t, addr @gpsi, NULL
    
    ;########################################################################################

    invoke GetDC, hwnd
    mov @dc,eax
    invoke GdipCreateFromHDC,@dc,addr @g

    invoke GlobalAlloc,GPTR,255
    mov @ws,eax
    
    invoke MultiByteToWideChar,CP_OEMCP,MB_PRECOMPOSED,addr _n,-1,@ws,255
    invoke GdipCreateFontFamilyFromName,@ws,NULL,addr @fm

    invoke GdipCreateFont,@fm,12,FontStyleRegular,UnitPoint,addr @ft

    invoke GdipCreateSolidFill,0ffff0000h,addr @br

    invoke GdipCreatePen2,@br,1,UnitPoint,addr @p

    invoke GdipCreateStringFormat,StringFormatFlagsDirectionRightToLeft,LANG_NEUTRAL,addr @sf

    invoke MultiByteToWideChar,CP_OEMCP,MB_PRECOMPOSED,addr _s,-1,@ws,255

    invoke lstrlen,addr _s
    inc eax
    shl eax,1
    mov @sl,eax

    mov @r4,10
    fild @r4
    fstp @r.X
    mov @r4,20
    fild @r4
    fstp @r.Y
    mov @r4,100
    fild @r4
    fstp @r.W
    mov @r4,20
    fild @r4
    fstp @r.H

    invoke GdipDrawString,@g,@ws,@sl,@ft,addr _r,NULL,@br
    .if eax != 0
    	invoke lstrlen,addr _err
    	invoke TextOut,@dc,0,0,addr _err,eax
    .else
    	invoke lstrlen,addr _ok
    	invoke TextOut,@dc,0,0,addr _ok,eax
    .endif

	invoke GdipDrawLineI,@g,@p,0,20,100,100
	
    invoke GlobalFree,@ws
    mov @ws,NULL
    
    invoke ReleaseDC,hwnd,@dc

    ;########################################################################################
    
    .if @sf != NULL
        invoke GdipDeleteStringFormat,@sf
	  mov @sf,NULL
    .endif
    .if @p != NULL
        invoke GdipDeletePen,@p
        mov @p,NULL
    .endif
    .if @br != NULL
        invoke GdipDeleteBrush,@br
        mov @br,NULL
    .endif
    .if @ft != NULL
        invoke GdipDeleteFont,@ft
        mov @ft,NULL
    .endif
    .if @fm != NULL
        invoke GdipDeleteFontFamily,@fm
        mov @fm,NULL
    .endif
    .if @g != NULL
        invoke GdipDeleteGraphics,@g
        mov @g,NULL
    .endif
	
    invoke GdiplusShutdown, addr @t

	ret
    
GdipTest endp